<?php

/*
PHPWidgets! 0.9a
(c) Northern Magic (http://www.nothern.ca)
ironstorm@users.sourceforge.net
------------------------------------------

## function PHPWidgets($template_object, $preproc)
inputs: 
  $template_object = pointer to your template object i.e. "$t" in $t = new Template('.','keep')
  $preproc = Do you wish to use IF VAR_EXISTS ELSE VAR_EXISTS.... blocks (requires upgraded templates.inc)
output: 
  N/A

## function load_variable_block($template_handle, $block_name = "PAGE_VAR")
inputs:
  $template_handle = handle for file holding the block
  $block_name = name of the block to load
output:
  The template object will have whatever variables were in the block loaded
  into it (set_var) and the block will be removed from the original page.

## function load_widget($widgets, $options)
input: 
   1) A static widget *.whtml only
   or 
   2) A dynamic widget *.ephp only
   or
   3) A dynamic widget w/ layout template *.whtml + *.ephp
   or
   4) An array containing any or all of the above types
output:
   files/vars are set in your main template_object $t

## function block_load_widget($template_handle, $block_name, $widgets, $options)
input:
   $template_name - the name of the template to effect
   $block_name - the name of the block to manipulate from $template_name
   $widgets & $options - see load_widget
ouput:
   files/vars set within your $template_name section.

*/

class PHPWidgets {
var $classname = "PHPWidgets";
var $version = "0.9a";

// Variable to use the preproc version
// Set to 0, if you are using the non-upgraded PHPLIB templates.inc 
var $preproc = "";  // PHP4 could replace this with a methond_exists call

var $widget_file_ext = ".whtml"; //Static - Stands for widget html
var $dwidget_file_ext = ".ephp"; //Dynamic - Stands for eval'ed PHP

var $template_object = "";

/******************
 Constructor
*/
function PHPWidgets($template_object, $preproc = 0)
{
  $this->template_object = $template_object;
  $this->preproc = $preproc;
}

function load_variable_block($template_handle, $block_name = "PAGE_VAR")
{
eval("global ".$this->template_object.";");
eval("\$t = ".$this->template_object.";"); 

  // Override any page variables (i.e. page_title)
  $t->set_block($template_handle, $block_name,""); // remove the block
  $extra_data = ereg_replace("\n"," ", trim($t->get($block_name)));
  $extra_data = ereg_replace('" "','", "', $extra_data);
  $extra_data = ereg_replace(') "','), "', $extra_data);
  if ($extra_data <> "")
    {
      eval("\$t->set_var(array($extra_data));");  
    }
  $t->set_var(array($block_name =>""));  

eval($this->template_object." = \$t;"); 
}


function widget_loader($widget, $options = "")
{ #### INTERNAL Function called by load_widget...

eval("global ".$this->template_object.";");
eval("\$t = ".$this->template_object.";"); 
        if(file_exists($widget.$this->dwidget_file_ext) && file_exists($widget.$this->widget_file_ext))
          { # Dynamic Widget that is has a template attached
            ## Not sure about this case
            $t->set_file(array($widget."_template"=>$widget.$this->widget_file_ext));
            eval(implode("", file($widget.$dwidget_file_ext)));
            if ($preproc)
              { $t->parse("$widget",$widget."_template", false, true); }
            else 
              { $t->parse("$widget",$widget."_template", false); }
          }
        else if(file_exists($widget.$this->dwidget_file_ext))
          { # Dynamic Widget that stands alone
            eval(implode("", file($widget.$this->dwidget_file_ext)));
            eval("\$t->set_var(array(\"".$widget."\"=>$".$widget."));");  
          }
        else if(file_exists($widget.$this->widget_file_ext))
          { # Static Widget from a file
            $t->set_file(array($widget."_template"=>$widget.$this->widget_file_ext));
            if ($preproc)
              { $t->parse("$widget",$widget."_template", false, true); }
            else 
              { $t->parse("$widget",$widget."_template", false); }
          }
        else 
          { # Error: Widget not found.
            echo "PHPWidgets Error: $widget not found.<br>\n";
            return;
          }
eval($this->template_object." = \$t;"); 
}


function load_widget($widgets, $options = "")
{
  
  if (is_array($widgets))
  {
     $widget_count = count ($widgets);
     for ($i = 0; $i < $widget_count; $i++)
       {

          # Do we have (widget1,option1),(..)
          if (is_array($widgets[$i]))
          {
             $widget = $widgets[$i][0];
             if (count($widgets[$i]) > 1)
             {
                $options = $widgets[$i][1];
             }
             else 
             { 
                $options = ""; 
             }
          }
          else # or Do we have (widget), .. ,(widget,option),(..))
          {
             $widget = $widgets[$i];
             $options = "";               
          }
          $this->widget_loader($widget, $options);
      }
   }
   else 
   {
      $this->widget_loader($widgets, $options);  
   }
} # End of Load_widget

function d($msg)
{ ### INTERNAL Print a debug message
  echo "<h1>[$msg]</h1>\n";
}

function block_load_widget($template_handle, $block_name, $widgets, $options = "")
{
eval("global ".$this->template_object.";");
eval("\$t = ".$this->template_object.";"); 

  $t->set_block($template_handle, $block_name, $block_name."_widget_block");

eval($this->template_object." = \$t;"); 

  $this->load_widget($widgets, $options);

eval("\$t = ".$this->template_object.";"); 

  if ($preproc)
   { $t->parse($block_name."_widget_block", "$block_name", false); }
  else 
   { $t->parse($block_name."_widget_block", "$block_name"); }

eval($this->template_object." = \$t;"); 
}

function widget_list($path = ".")
// Widgets starting with _ are not displayed...
{
  if ($fd_dir=opendir($path)) 
  {
    if ($path = ".") { $path = ""; }
    while ($file=readdir($fd_dir)) 
    {
      if (is_file($path.$file) && ($file[0] != "_") &&
            ( ereg(".*$this->widget_file_ext$", $file) || 
              ereg(".*$this->dwidget_file_ext$", $file) ))
      {
         //echo substr($path.$file."<br>\n"; 
         
         $file = ereg_replace($this->widget_file_ext,"",$file); 
         $file = ereg_replace($this->dwidget_file_ext,"",$file); 

         $files[] = ereg_replace(".","",$path).$file; 
      }
    }
 closedir($fd_dir);
 }
 return $files;
}

function build_body_tag($attribs, $bt = "page_bodytag")
{
 // Build the body tag attibutes.
 // Usage: <BODY {page_bodytag}>  
 // Future: build the style sheet too.
eval("global ".$this->template_object.";");
eval("\$t = ".$this->template_object.";"); 

// $t->set_file("$bt_template","$bt.ihtml");

  $t->set_var($attribs);

$body_and_css = '
 background="{background}"
 text="{text}"
 bgcolor="{bgcolor}"
 link="{link}"
 alink="{alink}"
 vlink="{vlink}"
 marginheight="{marginheight}"
 marginwidth="{marginwidth}"
 topmargin="{marginheight}"
 leftmargin="{marginwidth}"
';
/*
$body_and_css .= '>
<style TYPE="text/css">
<!--
BODY {
  font-size: {font-size};
  font-family: {font-family};
  font-weight: {font-weight}; 
  color: {text};
  background-color: {bgcolor};
  background-image: url({background});
}
-->
</style';
*/

$body_and_css = ereg_replace("\n "," ",$body_and_css);

$t->set_var($bt.'_template', $body_and_css);

 if ($preproc)
   {  $t->parse($bt, $bt."_template", false, true); }
 else 
   { $t->parse($bt, $bt."_template", false); }

eval($this->template_object." = \$t;"); 
}

function replace_widget($handle, $old, $new)
{
  eval("global ".$this->template_object.";");
  eval("\$t = ".$this->template_object.";"); 

  $yyy = $t->get_var($handle);

  if (!is_array($old))
  {
    $old = array($old);
   }

   reset($old);
   while (list ($key, $value) = each ($old)) {
     $yyy = ereg_replace($value, $new, $yyy);
   }

   $t->set_var($handle, $yyy);

   eval($this->template_object." = \$t;"); 
}


} // End PHPWidgets class

?>
